/* ========================================================================= *
 * FrozenList definition
 * ========================================================================= */
#include <stdlib.h>

#include "FrozenList.h"

struct node_t
{
    int data;
    FrozenList* next;
};

FrozenList* createFrozenList(const int* array, size_t length)
{
    if (length == 0)
        return NULL;

    FrozenList* previous = NULL;
    FrozenList* current;
    for(int i=((int)length)-1; i>=0; i--)
    {
        current = (FrozenList*) malloc(sizeof(FrozenList));
        if (!current)
        {
            freeFrozenList(previous);
            return NULL;
        }
        current->data = array[i];
        current->next = previous;
        previous = current;
    }
    return current;
}

void freeFrozenList(FrozenList* flist)
{
    if (!flist)
        return;
    FrozenList* next = flist->next;
    free(flist);
    freeFrozenList(next);
}

int getData(const FrozenList* flist)
{
    return flist->data;
}

FrozenList* getTail(FrozenList* flist)
{
    return flist->next;
}

FrozenList* setTail(FrozenList* flist, FrozenList* newTail)
{
    FrozenList* prev = flist->next;
    flist->next = newTail;
    return prev;
}
